Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0036776
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] 07. Sales managementmajoralways2017-09-04 11:492017-09-21 16:49
ReporterngarciaView Statuspublic 
Assigned Tomarkmm82 
PriorityurgentResolutionfixedFixed in Version3.0PR17Q4
StatusclosedFix in branchFixed in SCM revisionef2a84e698c4
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned Toaferraz
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0036776: Amounts in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process

DescriptionAmounts in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process

In CreateFrom class, the price precision is used for rounding amounts instead of standard precision
Steps To ReproduceChange the Format.xml to accept 3 decimals in prices

As System Admin role:
   Set Price Precision of EUR currency to 3

   Create a new sales price list, do not set it as Price Includes Tax
   Add 4 products to it with the following prices:
      101.15
      176.715
      8.33
      35.105

   Create a Sales Order
   Set the previously created price list
   Add the previously created 5 products (one unit of each, 2 units of the one with 101.15 price)
   Complete it
   Set its Invoice Terms as Immediate

   Create a Sales Invoice header
   Set the previously created price list
   Click on Create Lines From
   Add the 4 lines of the sales order with a price different from 0

   Check the total net amount (422.45) does not match with the sum of the Line Net Amount values in invoice lines (202.30 + 176.72 + 8.33 + 35.11 = 422.46)
      
   Check through database that the linenetamt is not rounded to standard precision but to priceprecision
TagsNo tags attached.
Attached Files

- Relationships Relation Graph ] Dependency Graph ]
depends on backport 00367933.0PR17Q3 closedmarkmm82 Amounts in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process 
depends on backport 00367943.0PR17Q2.3 closedmarkmm82 Amounts in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process 
depends on backport 00367953.0PR17Q1.4 closedmarkmm82 Amounts in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process 
blocks defect 0036705 closedmarkmm82 More than one pending payment plan detail for same invoice payment plan 

-  Notes
(0098820)
markmm82 (developer)
2017-09-04 18:55

Test Plan 1:
Change the Format.xml to accept 3 decimals in prices

As System Admin role:
   Set Price Precision of EUR currency to 3

   Create a new sales price list, do not set it as Price Includes Tax
   Add 4 products to it with the following prices:
      101.15
      176.715
      8.33
      35.105

   Create a Sales Order
   Set the previously created price list
   Add the previously created 5 products (one unit of each, 2 units of the one with 101.15 price)
   Complete it
   Set its Invoice Terms as Immediate

   Create a Sales Invoice header
   Set the previously created price list
   Click on Create Lines From
   Add the 4 lines of the sales order with a price different from 0

   Check the total net amount (422.46) matches with the sum of the Line Net Amount values in invoice lines (202.30 + 176.72 + 8.33 + 35.11 = 422.46) and Total Gross Amount is 511.18.
      
   Check through database that the linenetamt is rounded to standard precision.
   
Test for purchase flow and you will get same results.

Test Plan 2:
Change the Format.xml to accept 3 decimals in prices

As System Admin role:
   Set Price Precision of EUR currency to 3

   Create a new sales price list, do not set it as Price Includes Tax
   Add 4 products to it with the following prices:
      101.15
      176.715
      8.33
      35.105

   Create a Goods Shipment
   Add the previously created 5 products (one unit of each, 2 units of the one with 101.15 price)
   Complete it

   Create a Sales Invoice header
   Set the previously created price list
   Click on Create Lines From
   Add the 4 lines of the Goods shipment with a price different from 0

   Check the total net amount (422.46) matches with the sum of the Line Net Amount values in invoice lines (202.30 + 176.72 + 8.33 + 35.11 = 422.46) and Total Gross Amount is 511.18.
      
Test for purchase flow and you will get same results.
(0098832)
hgbot (developer)
2017-09-05 13:56

Repository: erp/devel/pi
Changeset: ef2a84e698c4c76bef4f8ef984d4055c64b6d862
Author: Mark <markmm82 <at> gmail.com>
Date: Mon Sep 04 12:44:00 2017 -0400
URL: http://code.openbravo.com/erp/devel/pi/rev/ef2a84e698c4c76bef4f8ef984d4055c64b6d862 [^]

Fixes issue 36776: Amounts in invoice lines and taxes rounded to price precision
instead of standard precision in Create Lines From process.

In CreateFrom class, the price precision was used for rounding amounts instead of
standard precision and it was causing differences with totals when invoices were
created from orders or shipments.

Now all prices are rounded with the price precision of it currency and amounts
with standard precision.

---
M src/org/openbravo/erpCommon/ad_actionButton/CreateFrom.java
M src/org/openbravo/erpCommon/ad_actionButton/CreateFrom_Invoice_data.xsql
---
(0098833)
hgbot (developer)
2017-09-05 13:57

Repository: erp/devel/pi
Changeset: f103322dedd4d728d88174ac9d887def053598c2
Author: Alvaro Ferraz <alvaro.ferraz <at> openbravo.com>
Date: Tue Sep 05 12:37:04 2017 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/f103322dedd4d728d88174ac9d887def053598c2 [^]

Related to issue 36776: Code review improvements

Retrieve currency standard precision instead of price precision in selectFromPO, selectFromPOUpdate, selectFromPOUpdateSOTrx and selectPriceList methods.
Do not round price actual with price precision when calculating line net amount.
Remove unused priceprecision variable.
Use data variable to retrieve currency standard precision when creating invoice from order and dataAux variable when creating invoice from receipt/shipment.

---
M src/org/openbravo/erpCommon/ad_actionButton/CreateFrom.java
M src/org/openbravo/erpCommon/ad_actionButton/CreateFrom_Invoice_data.xsql
---
(0098853)
aferraz (developer)
2017-09-05 18:19

Code review + Testing OK
(0099357)
hudsonbot (developer)
2017-09-21 16:49

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/9750b78d3e5c [^]
Maturity status: Test
(0099358)
hudsonbot (developer)
2017-09-21 16:49

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/9750b78d3e5c [^]
Maturity status: Test

- Issue History
Date Modified Username Field Change
2017-09-04 11:49 ngarcia New Issue
2017-09-04 11:49 ngarcia Assigned To => Triage Finance
2017-09-04 11:49 ngarcia Modules => Core
2017-09-04 11:49 ngarcia Triggers an Emergency Pack => No
2017-09-04 11:50 ngarcia Relationship added blocks 0036705
2017-09-04 11:50 ngarcia Issue Monitored: networkb
2017-09-04 11:50 ngarcia Summary Amount in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process => Amounts in Invoice lines and taxes are rounded to price precision instead of standard precision in Create Lines From process
2017-09-04 11:50 ngarcia Description Updated View Revisions
2017-09-04 12:30 aferraz Assigned To Triage Finance => markmm82
2017-09-04 16:03 markmm82 Status new => scheduled
2017-09-04 18:55 markmm82 Note Added: 0098820
2017-09-05 13:56 hgbot Checkin
2017-09-05 13:56 hgbot Note Added: 0098832
2017-09-05 13:56 hgbot Status scheduled => resolved
2017-09-05 13:56 hgbot Resolution open => fixed
2017-09-05 13:56 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/devel/pi/rev/ef2a84e698c4c76bef4f8ef984d4055c64b6d862 [^]
2017-09-05 13:57 hgbot Checkin
2017-09-05 13:57 hgbot Note Added: 0098833
2017-09-05 16:41 aferraz Status resolved => new
2017-09-05 16:41 aferraz Resolution fixed => open
2017-09-05 16:41 aferraz Status new => scheduled
2017-09-05 16:41 aferraz Status scheduled => resolved
2017-09-05 16:41 aferraz Resolution open => fixed
2017-09-05 18:19 aferraz Review Assigned To => aferraz
2017-09-05 18:19 aferraz Note Added: 0098853
2017-09-05 18:19 aferraz Status resolved => closed
2017-09-05 18:19 aferraz Fixed in Version => 3.0PR17Q4
2017-09-21 16:49 hudsonbot Checkin
2017-09-21 16:49 hudsonbot Note Added: 0099357
2017-09-21 16:49 hudsonbot Checkin
2017-09-21 16:49 hudsonbot Note Added: 0099358


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker